
// #include <stdio.h>

/* FreeRTOS */
#include "FreeRTOS.h"
#include "os_queue.h"
#include "os_task.h"
#include "os_semphr.h"

/* TMS570 */
#include "het.h"
#include "sci.h"
#include "gio.h"

/* main app */
#include "platform.h"
#include "tms570_configuration.h"
#include "globals.h"



static void prvQueueReceiveTask( void *pvParameters )
{
unsigned long ulReceivedValue;

	for( ;; )
	{
		xQueueReceive( xQueue, &ulReceivedValue, portMAX_DELAY );

        gioSetBit( hetPORT1, 17, 1 );
		vTaskDelay( 100 / portTICK_RATE_MS );
        gioSetBit( hetPORT1, 17, 0 );
	}
}

static void prvQueueSendTask( void *pvParameters )
{
    portTickType xNextWakeTime;
    unsigned long blink_interval = (unsigned long) pvParameters;
    unsigned long ulValueToSend = 1;

    xNextWakeTime = xTaskGetTickCount();

    for( ;; )
    {
        vTaskDelayUntil( &xNextWakeTime, blink_interval / portTICK_RATE_MS );

        xQueueSend( xQueue, &ulValueToSend, 0U );

    }
}

void main_app_main (void)
{

    gioSetDirection( hetPORT1, 0xFFFFFFFF );
    sciInit();

    globals_init();

    if( xQueue != NULL )
    {
        xTaskCreate( prvQueueReceiveTask,
                ( signed char * ) "Rx",
                configMINIMAL_STACK_SIZE,
                ( void * ) 50,  /* blink length */
                2, 		/* The priority assigned to the task. */
                NULL );									/* The task handle is not required, so NULL is passed. */

        xTaskCreate( prvQueueSendTask, ( signed char * ) "TX",
                configMINIMAL_STACK_SIZE, ( void * ) 500 /* send interval */, 
                1, NULL );

        xTaskCreate( serial_console_receive_task, ( signed char * ) "SCIRX",
                ( ( unsigned portSHORT ) 1023 ), ( void * ) 0, 1, NULL );

        /* Start the tasks and timer running. */
        vTaskStartScheduler();
    }
}
